#include "feux.h"

// les constructeurs

feux::feux() {}

/*******************************************************************
parametres :
    pin : pin de commande des feux
    step : duree du pas pour le fading
********************************************************************/
feux::feux(int pin, bool cde) : _pin(pin) {
    if (cde) {_cde = 0;} else {_cde = 255;}
    pinMode(_pin,OUTPUT);
    analogWrite(_pin,_cde);}

feux::feux(int pin, bool cde, int duree) : _pin(pin), fadingTiming(duree) {
    if (cde) {_cde = 0;} else {_cde = 255;}
    pinMode(_pin,OUTPUT);
    analogWrite(_pin,_cde);}

// le destructeur
feux::~feux(){}


// methode qui gere l'allumage des feux

void feux::ON() {
if (timer + fadingStep < millis())
    {
    timer = millis();
    switch (cycle)
        {
        case 0: {cycle = 1;fadingStep = fading;fadeValue = fading;break;}       // cycle0->eteint -> demarrage croissant->cycle1
        case 1: {analogWrite(_pin, fadeValue);fadeValue = fadeValue + fading;  // cycle1->croissance-> cycle1
                if (fadeValue > 255){fadingStep = fadingTiming;cycle = 2;}                      // cycle1->fin de croissance->cycle2
                break;}
        case 2: {cycle = 3;fadingStep = fadingTiming;fadeValue = 255;break;}              // cycle2->allume -> decroissant->cycle3
        case 3: {analogWrite(_pin, fadeValue);fadeValue = fadeValue - fading;   // cycle3->descroissance->cycle3
                if (fadeValue < 0){fadingStep = fadingTiming;cycle = 0;}                         // cycle3->fin de decroissance->cycle0
                break;}
        }
    }
}

// methode qui eteint les feux
void feux::OFF() {
    analogWrite(_pin, _cde);        // on eteint les feux
    etat = false;               // on est en phase OFF
}
